﻿/*
 * NOTE:    DO NOT POST ANY MODIFIED VERSIONS OF THIS TO THE FORUMS.
 * 
 *          DO NOT UTILIZE ANY PORTION OF THIS PLUGIN WITHOUT
 *          THE PRIOR PERMISSION OF AUTHOR.  PERMITTED USE MUST BE
 *          ACCOMPANIED BY CREDIT/ACKNOWLEDGEMENT TO ORIGINAL AUTHOR.
 * 
 * SetTheLeader Plugin
 * 
 * Author:  Bobby53
 * 
 */

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Styx.Logic;
using Styx.Helpers;
using Styx.Logic.Pathing;
using System.Threading;
using System.Diagnostics;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System.IO;
using System.Runtime.InteropServices;
using System.Xml.Linq;
using System.Net;
using Styx.Plugins.PluginClass;
using Styx;
using NSetLead;

namespace NSetLead
{
    public partial class ConfigForm : Form
    {
        public WoWPlayer chosenPlayer = null;

        public ConfigForm()
        {
            InitializeComponent();
        }

        private void btnSetLeader_Click(object sender, EventArgs e)
        {
            if (listView.SelectedItems.Count == 0)
            {
                MessageBox.Show("Choose a Player before clicking Set Leader");
                listView.Focus();
            }
            else
            {
                chosenPlayer = (WoWPlayer)listView.SelectedItems[0].Tag;
                this.DialogResult = DialogResult.OK;
                this.Close();
            }
        }

        private void listView_DoubleClick(object sender, EventArgs e)
        {
            btnSetLeader_Click(sender, e);
        }

        private void SetTheLeaderForm_Load(object sender, EventArgs e)
        {
            if (!ObjectManager.IsInGame || ObjectManager.Me == null ) //|| Battlegrounds.IsInsideBattleground)
            {
                MessageBox.Show("WOW is not ready for role assignments!" + Environment.NewLine + "use Refresh when in Party/Raid with role assignments", "SetTheLeader");
                return;
            }

            // Text = SetTheLeader.local.Name + " " + SetTheLeader.local.Version;
            ObjectManager.Update();
            Logging.Write(Color.Chocolate, "-- Group Count: {0}", CSetLead.groupList.Count);
            foreach (WoWPlayer p in CSetLead.groupList)
            {
                if (p.IsMe)
                    continue;

                string sRole = CSetLead.GetGroupRoleAssigned(p);
                Logging.Write(Color.Chocolate, "-- Group Member: {0} hp={1} is {2}", p.Class.ToString(), p.MaxHealth, sRole);

                ListViewItem lvi = new ListViewItem();
                lvi.Text = p.Name;
                lvi.Tag = p;

                ListViewItem.ListViewSubItem lvs = new ListViewItem.ListViewSubItem();
                lvs.Text = p.Class.ToString();
                lvi.SubItems.Add(lvs);

                lvs = new ListViewItem.ListViewSubItem();
                lvs.Text = sRole;
                lvi.SubItems.Add(lvs);

                lvs = new ListViewItem.ListViewSubItem();
                lvs.Text = p.MaxHealth.ToString();
                lvi.SubItems.Add(lvs);

                if (RaFHelper.Leader == p)
                    lvi.Selected = true;

                listView.Items.Add(lvi);
            }
        }

        private void SetTheLeaderForm_Shown(object sender, EventArgs e)
        {
            foreach (WoWPlayer p in CSetLead.groupList)
            {
                if (p.IsMe)
                    continue;

                ListViewItem lvi = new ListViewItem();
                lvi.Text = p.Name;
                lvi.Tag = p;

                ListViewItem.ListViewSubItem lvs = new ListViewItem.ListViewSubItem();
                lvs.Text = p.Class.ToString();
                lvi.SubItems.Add(lvs);

                lvs = new ListViewItem.ListViewSubItem();
                lvs.Text = CSetLead.GetGroupRoleAssigned(p);
                lvi.SubItems.Add(lvs);

                lvs = new ListViewItem.ListViewSubItem();
                lvs.Text = p.MaxHealth.ToString();
                lvi.SubItems.Add(lvs);

                if (RaFHelper.Leader == p)
                    lvi.Selected = true;
            }
        }

        private void btnRefresh_Click(object sender, EventArgs e)
        {
            listView.Clear();
            SetTheLeaderForm_Load(sender, e);
        }

        private void listView_SelectedIndexChanged(object sender, EventArgs e)
        {

        }
    }
}
